
var _ = require('underscore'),
    emitter = require('events').EventEmitter,
    crypto = require('crypto');
  
module.exports = function (params) {
    if (module.exports.debug) console.log('new model ', params);
    params = _.extend({}, params, this);
    this.property = this.model + '_';
    this.collection = [];
    var self = this;
    _.extend(this, new emitter, {
    
        comparator: function (collection) {
            if (module.exports.debug) console.log('sorting model ');
            return _.sortBy(collection, function (v) {
                //var proplen = self.property.length+1;
                //var foo = v.id.slice(proplen);
                //return Math.abs(foo);
                return v.sort;
            });
        },
        
        add: function (doc) {
            if (module.exports.debug) console.log('adding model ');
            self.create(doc);
        },
        
        create: function (doc) {
            if (module.exports.debug) console.log('creating model ');

            var md5sum = crypto.createHash('md5');
            md5sum.update(String(Math.random()));
            var newid = self.property + md5sum.digest('hex');
            
            doc.id = doc.id || newid;
            doc.sort = doc.sort || self.collection.length;
            
            if (!doc.name) return;
            db.get(self.model, function (e, collection) {
                if (e) console.log(e);                
                collection = JSON.parse(collection); 
                collection.push(doc);
                collection = JSON.stringify(collection);
                db.set(self.model, collection, function (e) {
                    self.emit('create', doc);
                    publish.publish(self.model, collection);
                });
            });
        },
        
        read: function (fn) {
            if (module.exports.debug) console.log('reading model ');
            db.get(self.model, function (e, collection) {
                fn(JSON.parse(collection));
            });
        },
        
        update: function (doc) {
            if (module.exports.debug) console.log('updating model ');
            if (!doc.name) return;
            db.get(self.model, function (e, collection) {
                collection = _.reject(JSON.parse(collection), function (itm) {
                    return (itm.id === doc.id);
                });
                collection.push(doc);
                db.set(self.model, JSON.stringify(collection), function (e) {
                    self.emit('update', collection);
                    publish.publish(self.model, JSON.stringify(collection));
                });
            });
        },
        
        remove: function (ids) {
            if (module.exports.debug) console.log('removing model ');
            db.get(self.model, function (err, collection) {
                if (typeof ids === 'undefined') return;
                if (typeof ids === 'string') ids = [].concat(ids);
                collection = _.filter(JSON.parse(collection), function (itm) { 
                    if (_.indexOf(ids, itm.id) < 0) {
                        return true;
                    } else {
                        self.emit('remove', itm);
                        return false;
                    }
                });
                collection = JSON.stringify(collection);
                db.set(self.model, collection);
                publish.publish(self.model, collection);
            });
        },
        
        sync: function (newdocs) {
            if (module.exports.debug) console.log('synchronizing model ');
            if (!newdocs) return;
            newdocs = self.comparator(newdocs);
            
            var ids = _.pluck(self.collection, 'id');
            for (var i=0, l=newdocs.length;i<l;i++) {
                var id = newdocs[i].id;
                var exist = _.include(ids, id);
                if (!exist) {
                    //self.collection.push(newdocs[i]);
                    self.emit('read', newdocs[i]);
                    self.initialize && self.initialize(newdocs[i]);
                }
                
            }
            
            var ids = _.pluck(newdocs, 'id');
            for (var i=0, l=self.collection.length;i<l;i++) {
                var item = self.collection[i];
                var exist = _.include(ids, item.id);
                if (!exist) {
                    self.emit('remove', item);
                }
                
            }
                
            self.collection = newdocs;
            self.emit('sync', self.collection);
        }
        
    });
    return this;

};

module.exports.extend = function (params) {
    if (module.exports.debug) console.log('extending model ');
    return function (opts) {
        return module.exports.call(params, opts);
    }
};

